/*
 * Description : A program bekeri, hogy mennyi neptun kodot generaljunk, majd
 *               a megadott darabszamu NKHOSSZ hosszusagu szambol es/vagy betubol
 *               allo neptun kodot general fuggvennyel is megoldva.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.22
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

enum {
    MINNEPTUNDB=1,
    MAXNEPTUNDB=99,
    NKHOSSZ=6
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

void NKgenerator(int darabszam) {
    int i,k;

    for(k=0; k<darabszam; ++k) {
        printf("%2d. Neptunkod: ", k+1);
        for(i=0; i<NKHOSSZ; ++i) {
            /* randommal dontjuk el, hogy betut vagy szamot generaljunk */
            if(rand()%2 == 0)
                /* itt nagy betut generalunk */
                printf("%c", rand()%26 + 'A');
            else
                /* itt szamot generalunk */
                printf("%d", rand()%10);
        }
        printf("\n");
    }
    printf("\n");
}


void main (void) {
    int i, k, vege=0, darabszam;
    char tmp[7+1];

    clrscr();
    randomize();

    printf("Neptunkod generalo program.\n"
           "---------------------------\n"
           "Kerem adja meg, hogy hany neptunkodot generaljunk (%d-%d):\n", MINNEPTUNDB, MAXNEPTUNDB);

    do {
        if (!getline(tmp, 3))
            printf("Nem adhat meg ures sort!\n");
        else if (strlen(tmp)>2)
            printf("Tul sok karaktert adott meg!\n");
        else if (!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            darabszam=atoi(tmp);
            if (darabszam < MINNEPTUNDB)
                printf("Minimum %d-t adjon meg!\n", MINNEPTUNDB);
            else
                vege=1;
        }
    } while (!vege);

    printf("Fuggvennyel generalva:\n"
           "----------------------\n");
    NKgenerator(darabszam);

    printf("Fuggveny nelkul generalva:\n"
           "--------------------------\n");
    for(k=0; k<darabszam; ++k) {
        printf("%2d. Neptunkod: ", k+1);
        for(i=0; i<NKHOSSZ; ++i) {
            /* randommal dontjuk el, hogy betut vagy szamot generaljunk */
            if (rand()%2 == 0)
                /* itt nagy betut generalunk */
                printf("%c", rand()%26+'A');
            else
                /* itt szamot generalunk */
                printf("%d", rand()%10);
        }
        printf("\n");
    }

    getch();
}