/* 09_3.C: Legfeljebb 36-os alap szmok konverzija, de az alap csak
		   fordtsi idben vltoztathat. */

#include <stdio.h>
#define MAX 128		/* Az input puffer mrete. */
#define alap 16		/* A szmrendszer alapja. */

int getline(char[], int);
int ell36(char[], int);
long toi36(char[], int);

void main(void){
	char be[MAX+1];

	printf("A szmrendszer alapja: %d\n", alap);
	while(printf("Adjon meg egy szmot: "), getline(be,MAX))
		if(ell36(be, alap)) printf("Konvertlva: %ld\n", toi36(be, alap));
		else printf("Formailag hibs %d alap szm.\n", alap); }

/* Visszaadja a beolvasott karaktersorozat hosszt. s tmbbe olvas,
   lim a karakterlnc maximlis hossza. Az s tmbnek teht legalbb
   lim+1 mretnek kell lennie. (A lnczr '\0' karakternek is kell
   hely.) */

int getline(char s[], int lim){
	int i,c;
	for(i=0; i<lim && (c=getchar())!=EOF && c!='\n'; ++i) s[i]=c;
	s[i]='\0';
	while(c!=EOF && c!='\n') c=getchar();
	return i; }

/* "Az s karakterlnc a alap szm-e?" krdsre ad logikai vlaszt
   a fggvny. */
int ell36(char s[], int a){
	int i;

	if(a<=10)
		for(i=0; s[i]>='0' && s[i]<a+'0'; ++i);
	else
		for(i=0; s[i]>='0'&&s[i]<='9' || s[i]>='a'&&s[i]<'a'+a-10 ||
			s[i]>='A'&&s[i]<'A'+a-10;++i);
	if(s[i]) return 0;
    else return 1; }

/* Az s karakterlncot a alap szmnak tekintve long-g konvertlja,
   s ez a rutin visszaadott rtke. */
long toi36(char s[], int a){
	int i;
	long n=0l;

	if(a<=10)
		for(i=0; s[i]>='0'&&s[i]<a+'0'; ++i) n=a*n+s[i]-'0';
	else
		for(i=0; s[i]>='0'&&s[i]<'9' ||
				 s[i]>='a'&&s[i]<a+'a'-10 ||
				 s[i]>='A'&&s[i]<a+'A'-10; ++i)
			if(s[i]>='0'&&s[i]<='9') n=n*a+s[i]-'0';
			else if(s[i]>='a'&&s[i]<'z') n=n*a+s[i]-'a'+10;
			else n=n*a+s[i]-'A'+10;
    return n; }