/*
 * Description : Az ANSI C forrraskod altalanos felepitese
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.21
 */
 /*******************************************************************************
 * Eloszor a kulonbozo fejfajlok (header) megadasa szukseges, mivel ezek a
 * fajlok tartalmazzak a beepitett fuggvenyek hasznalatahoz szukseges konstansok
 * definicioit es a fuggvenyek prototipusait. pl.:
 */
#include <stdio.h>

/*
 * Azon kulonbozo makrok definicioi, amelyek a fajlon belul globalis
 * lathatosaggal rendelkeznek es amik megkonnyitik a programjaink kesobbi
 * modositasait mert ezen ertekeket eleg egy helyen modositani. pl.:
 */
#define SZOVEG   "Az ANSI C altalanos felepitese... "
#define MAXHOSSZ 30

/*******************************************************************************
 * Ide kerulnek azok a fuggvenyek, fuggveny prototipusok es adatszerkezet
 * definiciok amiket a kesobbiekben sajat magunknak kell megirni. pl.:
 */
void ownPrintf(const char *string) {
    for (; *string; ++string)
        putchar(*string);
}

/*
 * Fuggvenyprototipus, ami a visszateresi ertekbol, a fuggveny nevebol es a
 * parameterek tipusabol, sorrendjebol all, lasd az oldal legalja. pl.:
 */
void ownPrintfWithPrototype(const char *array);

/*
 * Kulonbozo adatszerkezetek, pl. strukturak definicioi. pl.:
 */
struct profil {
    short int eletkor;
    float     testsuly;
    char      nev[MAXHOSSZ+1];
};

/*******************************************************************************
 * A main fuggvenyt minden C programnak pontosan egyszer kell tartalmaznia
 * mivel a program inditasakor az OS ide adja at a vezerlest, gyakorlatilag
 * innen indul a program vegrehajtasa. pl.:
 */
void main(void) {
    /*
     * Itt deklaraljuk(definialjuk) a sajat valtozokat es konstansokat melyek a
     * main fuggvenyen belul globalis lathatosaggal rendelkezenk. pl.:
     */
    char karakterek[] = "nem is olyan bonyolult.\n";

    /*
     * Ez utan jonnek a kulonbozo fuggvenyhivasok, iteraciok, szelekciok,
     * adatmodosito muveletek.
     */
    ownPrintf(SZOVEG);
    ownPrintfWithPrototype(karakterek);

    /*
     * Var egy billentyu lenyomasaig, ha kihagyjuk, a program "elfut" a
     * a kepernyorol ha nem konzolbol futtatjuk, termeszetesen -1 pont jar
     * erte a vizsgan. :-)
     */
    getch();
}

/*******************************************************************************
 * Ide is kerulhetnek azok a fuggvenyek amiket a kesobbiekben sajat magunknak
 * kell megirni, viszont ebben az esetben a main fuggveny ele egy
 * fuggvenyprototipust kell irnunk amibol a fordito megtudja a fuggveny:
 *  - visszateresi ertekenek a tipusat
 *  - a fuggveny nevet
 *  - a formalis parameterek tipusait, szamat es sorrendjet
 */
void ownPrintfWithPrototype(const char *array) {
    for (; *array; ++array)
        putchar(*array);
}