/*
 * Description : Tavolugras
 *               A feladat leirasat lasd a feladat.doc fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.23
 */
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

enum {
    MAXHOSSZ=10,
    MINUGRAS=0,
    MAXUGRAS=10,
    MINRAJTSZAM=1,
    MAXRAJTSZAM=100,
    MAXVERSENYZOK=100
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]) {
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int lebeg(char s[]) {
    int i=0, kezd;
    while(isspace(s[i])) ++i;
    if(s[i]=='+'||s[i]=='-') ++i;
    kezd=i;
    while(isdigit(s[i])) ++i;
    if(s[i]=='.') ++i;
    while(isdigit(s[i])) ++i;
    if(i==kezd||kezd+1==i&&s[kezd]=='.') return 0;
    if(toupper(s[i])=='E'){
    ++i;
    if(s[i]=='+'||s[i]=='-')++i;
    if(!isdigit(s[i])) return 0;
    while(isdigit(s[i])) ++i;}
    if(isspace(s[i])||!s[i]) return 1;
    else return 0;
}

struct adatok {
    int rajtszam;
    double ugras;
};

void main(void) {
    double csere, osszeg=0;
    char tmp[MAXHOSSZ+2];
    struct adatok versenyzok[MAXVERSENYZOK];
    int ok, vege=0, versenyzodb=0, i, j;
    
    clrscr();

    printf("Tavolugras adminisztralo program.\n");

    do {
        ok=0;
        printf("Kerem adja meg a(z) %d. versenyzo rajtszamat (%d-%d):\n", versenyzodb+1, MINRAJTSZAM, MAXRAJTSZAM);
        do {
            if (!getline(tmp, 4)) {
                printf("Ures sort utott, vege a bekeresnek.\n\n");
                vege=1;
                ok=1;
            } else if (strlen(tmp) > 3) {
                printf("A versenyzo rajtszama maximum 3 karaketrbol allhat!\n");
            } else if (!egesz(tmp)) {
                printf("Nem egesz szamot adott meg!\n");
            } else {
                versenyzok[versenyzodb].rajtszam = atoi(tmp);

                if (versenyzok[versenyzodb].rajtszam > MAXRAJTSZAM)
                    printf("A legnagyobb rajtszam maxim %d lehet!\n", MAXRAJTSZAM);
                else if (versenyzok[versenyzodb].rajtszam < MINRAJTSZAM)
                    printf("A legkisseb rajtszam min %d legyen!\n", MINRAJTSZAM);
                else
                    ok=1;
            }
        } while(!ok);

        if (!vege) {
            ok=0;
            printf("Kerem adja meg a(z) %d. versenyzo ugrasat (%d-%d):\n", versenyzodb+1, MINUGRAS, MAXUGRAS);
            do {
                if(!getline(tmp, MAXHOSSZ+1))
                    printf("Nem adhat meg ures sort!\n");
                else if (!lebeg(tmp))
                    printf("Nem lebegopontos szamot adott meg!\n");
                else {
                    versenyzok[versenyzodb].ugras = atof(tmp);

                    if (versenyzok[versenyzodb].ugras > MAXUGRAS)
                        printf("A legnagyobb ugras maxim %d lehet!\n", MAXUGRAS);
                    else if (versenyzok[versenyzodb].ugras < MINUGRAS)
                        printf("A legkisseb ugras min %d legyen!\n", MINUGRAS);
                    else {
                        ++versenyzodb;
                        ok=1;
                    }
                }
            } while(!ok);
        }        
    } while(!vege);
    
    for(i=0; i<versenyzodb; ++i) {
        for(j=0; j<versenyzodb-1; ++j) {
            if (versenyzok[j].ugras < versenyzok[j+1].ugras) {
                csere = versenyzok[j].ugras;
                versenyzok[j].ugras = versenyzok[j+1].ugras;
                versenyzok[j+1].ugras = csere;
            }
        }
    }
    
    if (versenyzodb) {
        for (i=0; i<3 && i<versenyzodb; ++i)
            printf("%d. helyezett %d rajtszamu versenyzo %.2fm ugrassal.\n", i+1, versenyzok[i].rajtszam, versenyzok[i].ugras);
            
        for (i=0; i<versenyzodb; ++i)
            osszeg += versenyzok[i].ugras;
            
        printf("\n\nAz ugrasok atlagos hossza %.2f meter volt.\n", osszeg/versenyzodb);
    } else {
        printf("\n\nEgy versenyzot sem adott meg.\n");
    }
    getch();
}