/*
 * Description : Zh ertekelo
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.25
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <conio.h>

enum {
    MINPONT=1,
    MAXPONT1=40,
    MAXPONT2=60
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int jegy(int maxpont, int elertpont){
    double szazalek = elertpont * 100 / (double)maxpont;

    if (szazalek > 89)
        return 5;

    if (szazalek > 75)
        return 4;

    return 0;
}

void main(void){
    int pont1, pont2, i, ok, erdemjegy;
    char tmp[5];

    clrscr();

    do {
        printf("Kerem adja meg a hallgato elert eredmenyeit. EOF vagy ures sorra kilepunk.\n"
               "--------------------------------------------------------------------------\n");
        ok=0;
        printf("Kerem adja meg az elso ZH eredmenyet (min %d max, %d pont):\n", MINPONT, MAXPONT1);
        do {
            if(!getline(tmp, 3)) {
                printf("Ures sort utott, a program kilep!\n");
                getch();
                exit(0);
            } else if (strlen(tmp) > 2)
                printf("Tul hosszu karaktersorozatot adott meg!\n");
            else if (!egesz(tmp))
                printf("Nem egesz szamot adott meg!\n");
            else {
                pont1 = atoi(tmp);
                if (pont1 < MINPONT)
                    printf("A ZH-n minimum %d pontot kell elerni!\n", MINPONT);
                else if (pont1 > MAXPONT1)
                    printf("A ZH-n maximum %d pontot lehet elerni!\n", MAXPONT1);
                else {
                    ok=1;
                    erdemjegy = jegy(MAXPONT1, pont1);
                    if (erdemjegy == 0)
                        printf("%d pontra nem kaphatna megajanlott jegyet\n\n", pont1);
                    else if (erdemjegy == 4)
                        printf("%d pontra negyes megajanlott jegy jarna.\n\n", pont1);
                    else
                        printf("%d pontra otos megajanlott jegy jarna.\n\n", pont1);
                }
            }
        } while (!ok);

        ok=0;
        printf("Kerem adja meg a masodik ZH eredmenyet (min %d max, %d pont):\n", MINPONT, MAXPONT1);
        do {
            if(!getline(tmp, 3)) {
                printf("Ures sort utott, a program kilep!\n");
                getch();
                exit(0);
            } else if (strlen(tmp) > 2)
                printf("Tul hosszu karaktersorozatot adott meg!\n");
            else if(!egesz(tmp))
                printf("Nem egesz szamot adott meg!\n");
            else {
                pont2 = atoi(tmp);
                if (pont2 < MINPONT)
                    printf("A ZH-n minimum %d pontot lehet elerni!\n", MINPONT);
                else if (pont2 > MAXPONT2)
                    printf("A ZH-n maximum %d pontot lehet elerni!\n", MAXPONT2);
                else {
                    ok=1;
                    erdemjegy = jegy(MAXPONT2, pont2);
                    if(erdemjegy == 0)
                        printf("%d pontra nem kaphatna csak negyesnel rosszabb jegyet.\n\n", pont2);
                    else if (erdemjegy == 4)
                        printf("%d pontra negyes megajalott jegy jarna.\n\n", pont2);
                    else
                        printf("%d pontra otos megajanlott jegy jarna.\n\n", pont2);
                }
            }
        } while (!ok);

        printf("   ---   VEGEREDMENY   ---\n");
        erdemjegy = jegy((MAXPONT1+MAXPONT2), (pont1+pont2));

        if (erdemjegy == 0)
            printf("%d pontra nem kaphatna megajanlott jegyet!\n\n", pont1+pont2);
        else if (erdemjegy == 4)
            printf("%d pontra negyes megajanlott jegy jar.\n\n", pont1+pont2);
        else
            printf("%d pontra otos megajanlott jegy jar.\n\n", pont1+pont2);
    } while (1);
}