/*
 * Description : Ellenorzo
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.25
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <conio.h>

enum {
    SZEMIGHOSSZ=8,
    MAXNEVHOSSZ=30
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int nevell(char s[]) {
    int space=0, i;

    if (!isupper(s[0]) || !isalpha(s[1]))
        return 1;

    for (i=1; s[i]; ++i)
        if (isspace(s[i]))
            ++space;

    if (!space)
        return 1;

    for (i=1; isalpha(s[i]); ++i);
    for (; isspace(s[i]); ++i);

    if (!isupper(s[i]) || !isalpha(s[i + 1]))
        return 1;

    return 0;
}

int szigell(char s[]) {
    int i, szamjegy=0, betu=0;

    for (i=0; s[i]; ++i) {
        if (isalpha(s[i]))
            ++betu;

        if (isdigit(s[i]))
            ++szamjegy;

        s[i]=toupper(s[i]);
    }

    if (szamjegy!=6 || betu!=2)
        return 1;

    return 0;
}

void main(void) {
    char tmp[MAXNEVHOSSZ+2];

    clrscr();

    do {
        printf("Kerem adjon meg egy nevet:\n"
               "--------------------------\n");
        if (!getline(tmp, MAXNEVHOSSZ+1)) {
            printf("Ures sort utott, a program kilep!\n");
            getch();
            exit(0);
        } else if (strlen(tmp) > MAXNEVHOSSZ)
            printf("A nev maximum %d karakterbol alljon!\n", MAXNEVHOSSZ);
        else if (!nevell(tmp))
            printf("A megadott %s nev helyes.\n", tmp);
        else
            printf("A megadott %s nev nem helyes.\n", tmp);

        printf("Kerem adja meg a nevhez tartozo szemelyigazolvanyszamot:\n"
               "--------------------------------------------------------\n");
        if(!getline(tmp, SZEMIGHOSSZ+1)) {
            printf("Ures sort utott, a program kilep!\n");
            getch();
            exit(0);
        } else if(strlen(tmp) > SZEMIGHOSSZ)
            printf("A szemelyigazolvanyszam max. 8 karakterbol allhat!\n");
        else if(!szigell(tmp))
            printf("A megadott %s szemelyigazolvany szam helyes.\n", tmp);
        else
            printf("A megadott %s szemelyigazolvany szam nem helyes.\n", tmp);
    } while (1);
}