/*
 * Description : Kivansaglista
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.30
 */
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#define TILTOTTKIVANSAG "Ferrari"
#define KERESETTSZO     "jatek"
#define MINAR           100000000
#define MAXAR           200000000

enum {
    EURO=280,
    MAXKIVANSAGDB=50,
    MAXKIVANSAGHOSSZ=100,
};

struct kivansag {
    char nev[MAXKIVANSAGHOSSZ+1];
    long int ar;
};

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int jokivansag(char kivansag[]) {
    int i;

    if (!isupper(kivansag[0]))
        return 0;

    for (i=0; kivansag[i]; ++i)
        if (!isalpha(kivansag[i]) && !isspace(kivansag[i]))
            return 0;
    return 1;
}

void rendez(struct kivansag kivansagok[], int kivansagdb) {
    struct kivansag tmp;
    int i, j;

    for (i=0; i<kivansagdb; ++i) {
        for (j=0; j<kivansagdb-1; ++j) {
            if (kivansagok[j].ar < kivansagok[j+1].ar) {
                tmp = kivansagok[j];
                kivansagok[j] = kivansagok[j+1];
                kivansagok[j+1] = tmp;
            }
        }
    }
}

void main(void) {
    struct kivansag kivansagok[MAXKIVANSAGDB];
    char tmp[MAXKIVANSAGHOSSZ+2];
    int bekert=0, keresettszo=0, i, ok, vege=0;
    long int ar;

    clrscr();

    do {
        printf("Kerem adja meg a(z) %d. kivansagot:\n", bekert+1);
        ok=0;
        do {
            if (!getline(tmp, MAXKIVANSAGHOSSZ+1)) {
                printf("Ures sort utott, vege a bekeresnek.\n\n");
                vege=1;
                ok=1;
            } else if (strlen(tmp) > MAXKIVANSAGHOSSZ)
                printf("A kivansag max. %d karakterbol alljon!\n", MAXKIVANSAGHOSSZ);
            else if (!jokivansag(tmp))
                printf("A kivansag nagy betuvel kezdodjn, csak betuk es feher karakterek lehetnek benne!\n");
            else if (strcmp(tmp, TILTOTTKIVANSAG) == 0)
                printf("Ezt nem kivanhatja!\n");
            else {
                strcpy(kivansagok[bekert].nev, tmp);

                if (strstr(tmp, KERESETTSZO))
                    ++keresettszo;

                ok=1;
            }
        } while(!ok);

        if (!vege) {
            printf("Kerem adja meg a(z) %d. kivansag arat:\n", bekert+1);
            ok=0;
            do {
                if (!getline(tmp, MAXKIVANSAGHOSSZ+1))
                    printf("nem adhat meg ures sort!\n");
                else if (!egesz(tmp))
                    printf("Csak egesz szamot adhat meg!\n");
                else {
                    ar = atol(tmp);

                    if (ar < MINAR)
                        printf("A kivansag ara minimum %ldFt legyen!\n", MINAR);
                    else if (ar > MAXAR)
                        printf("A kivansag ara maximum %ldFt legyen!\n", MAXAR);
                    else {
                        kivansagok[bekert].ar = ar;
                        ++bekert;
                        ok=1;
                    }
                }
            } while(!ok);
        }
    } while(!vege);

    if (bekert != 0) {
        rendez(kivansagok, bekert);

        printf("%ddb kivansagban szerepelt a(z) %s szo.\n", keresettszo, KERESETTSZO);
        printf("A legertekesebb ajandek %s %ldFt -ba kerul.\n", kivansagok[0].nev, kivansagok[0].ar);
        printf("A legolcsobb ajandek    %s %ldFt -ba kerul.\n", kivansagok[bekert-1].nev, kivansagok[bekert-1].ar);

        for (i=0; i<bekert; ++i)
            printf("%s %ldFt ami %.0fEuro.\n", kivansagok[i].nev, kivansagok[i].ar, (double)kivansagok[i].ar/EURO);
    } else {
        printf("Egy kivansagot sem adtak meg!\n");
    }

    getch();
}