/*
 * Description : Testmagassag
 *               A feladat leirasat lasd a feladat.pdf fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.30
 */
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#define INCH 2.54
#define FOOT 12

enum {
    MAXHOSSZ=100,
    MINMAGASSAG=140,
    MAXMAGASSAG=210
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int jomagassag(char magassag[]) {
    int i;

    for (i=0; i<3; ++i)
        if (!isdigit(magassag[i]))
            return 0;

    if (magassag[strlen(magassag)-2]!='c' || magassag[strlen(magassag)-1]!='m')
        return 0;

    ++i;

    for (; isspace(magassag[i]) && magassag[i]; ++i)
        ;

    if (magassag[i]!='c' || magassag[i+1]!='m')
        return 0;

    return 1;
}

void angolhossz(int hl, int *h2l, float *h2h) {
    float huvelyk;

    huvelyk = hl / INCH;
    *h2l = huvelyk / FOOT;
    *h2h = huvelyk - (*h2l * FOOT);
}

void main(void) {
    int ok=0, magassag, lab;
    char tmp[MAXHOSSZ+2];
    float huvelyk;

    printf("Kerem adja meg a testmagassagat xxx cm formatumban:\n");
    do {
        if (!getline(tmp, MAXHOSSZ+1))
            printf("Nem adhat meg ures sort!\n");
        else if (strlen(tmp) > MAXHOSSZ)
            printf("Maximum %d hosszu karaktersorozatot adhat meg!\n", MAXHOSSZ);
        else if (!jomagassag(tmp))
            printf("A magassag nem megfelelo formatumban van megadva!\n");
        else {
            magassag = 100*(tmp[0]-'0') + 10*(tmp[1]-'0') + (tmp[2]-'0');

            if (magassag > MAXMAGASSAG)
                printf("A felhasznalo max. %d cm magas lehet!\n", MAXMAGASSAG);
            else if (magassag < MINMAGASSAG)
                printf("A felhasznalo min. %d cm magas legyen!\n", MINMAGASSAG);
            else
                ok=1;
        }
    } while(!ok);

    angolhossz(magassag, &lab, &huvelyk);

    printf("Magassag: %d cm ami %d lab %2.1f huvelyk.\n", magassag, lab, huvelyk);

    getch();
}